﻿Public Class CheckedListBoxDropDown

    Public Sub New(ByVal items As String())
        InitializeComponent()
        For Each item As String In items
            CheckedListBox1.Items.Add(item)
        Next
    End Sub

    Private Sub CheckedListBoxDropDown_Open(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Open
        'Check items which are included in text (useful if used as a grid editor)
        Dim s As String = OwnerControl.Text
        For i As Integer = 0 To CheckedListBox1.Items.Count - 1
            If s.Contains(CheckedListBox1.Items(i).ToString()) Then
                CheckedListBox1.SetItemChecked(i, True)
            Else
                CheckedListBox1.SetItemChecked(i, False)
            End If
        Next
        CheckedListBox1.SelectedIndex = -1
    End Sub

    Private Sub CheckedListBoxDropDown_PostChanges(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.PostChanges
        'Format selected items into comma separated list
        Dim conc As String = ""
        For Each item As String In CheckedListBox1.CheckedItems
            conc += item & ", "
        Next
        If conc.Length > 0 Then
            conc = conc.Remove(conc.LastIndexOf(","c), 2)
        End If
        OwnerControl.Value = conc
    End Sub
End Class